#include <ctime>
#include <cstdlib>
#include <unistd.h>

#include "misc.h"
#include "users.h"
#include "queue.h"

#include "d1.cc"
#include "d2.cc"

const tttlist *lista = NULL;

static tttobj argh(0,"Q","");

static enum states { nothing, waiting, active } state = nothing;
static const string thechan="#gurb";
static int myid, waitingid;
static string reply;
static bool danced=false;
static const tttobj *yippee;
static int chatid;

// Per sentence
#define TYPEDELAYONCE 2000000
// Per line
#define TYPEDELAYMIN  500000
// Per char
#define TYPEDELAYCHR  160000

// In seconds
#define RESPONSETIMEOUT 4*60

// guu/ok timeout in seconds
#define GUUTIMEOUT 60

// Required idle before debating is 1.8 - 5 hours
#define IDLEMIN int(3600*3)
#define IDLEMAX int(3600*5)


// Do we have to end
bool TTTDead()
{
	return cin.bad();
}

static const string puh()
{
	return ""; //":" + mynick + "!a@b ";
}

static const string strfix(const string &S)
{
	string s;
	unsigned b=S.size();
	for(unsigned a=0; a<b; a++)
		if(S[a]=='$' && isdigit(S[a+1]))
			s += botit[S[++a]-'1'];
		else
			s += S[a];
	return s;
}

// Send debate entry, possibly multiple lines
static void OutText(string s)
{
	usleep(TYPEDELAYONCE);
	for(;;)
	{
		unsigned p = s.find('\n');
		
		unsigned l = p > s.size() ? s.size() : p;
		
		string S = strfix(s.substr(0, l));
		usleep(TYPEDELAYMIN + (l + rand()%4) * TYPEDELAYCHR);
		cout << puh() << "PRIVMSG " << thechan << " :" << S << endl << flush;
		if(p > s.size())break;
		s.erase(0, p+1);
	}
}

// 10 ticks = one second
extern void LoopRead(long maxticks);

// Called by ttt
const tttobj &DoQuery(const tttlist &s)
{
	waitingid = s[0].id;
	
	if(waitingid == myid)
	{
		unsigned r = rand() % s.size();
		//unsigned(rand() * double(s.size()-1) / double(RAND_MAX+1.0));
		OutText(s[r].text);
		return s[r];
	}
	
	reply = "";	
	lista = &s;
	
	danced = false;
	
//	cout << "PRIVMSG bisqwit :(debug) entering loop\n" << flush;
	
	// Give about 4 minutes of time to respond
	LoopRead(10*RESPONSETIMEOUT);
	
//	if(!danced)
//		cout << "PRIVMSG bisqwit :(debug) reply timeout with '" << reply << "'\n";
//	else	
//		cout << "PRIVMSG bisqwit :(debug) danced!\n";
//	cout << flush;
	
	reply = "";
	if(danced)
	{
		danced = false;
		if(yippee)
			return *yippee;
	}	
	return argh;
}

// We got it
static void Dance(const tttobj &s)
{
	danced = true;
	yippee = &s;
}

static time_t lastmsg;

// Let's begin
static void InitDebate(int num, int whoami)
{
	myid = whoami;
	state = active;
	
//	cout << "PRIVMSG bisqwit :(debug) InitDebate called with num="<<num<< ", whoami="<<whoami << "\n" << flush;

	cout << "AWAY :\n" << flush;
	
	switch(num)
	{
		case 0: d1_ttt(); break;
		case 1: d2_ttt(); break;
	}
	
	cout << "AWAY :Zzzzzz\n" << flush;
	
	cerr << "closed\n";
	
	state = nothing;
}

static void Initiate(int n)
{
	chatid = n;
	
//	cout << "PRIVMSG bisqwit :(debug) Initiate called with " << n << "\n" << flush;
	
	vector<string>::iterator i;
P1:	for(i=botit.begin(); i!=botit.end(); i++)
		if(*i == mynick)
		{
			botit.erase(i);
			goto P1;
		}
	
	string s1 = str(botit, ',');

	botit.insert(botit.begin(), mynick);
	
	string s2 = str(botit, ' ');
	
	cout << puh() << "PRIVMSG " << s1 << " :guu " << n << ' ' << s2 << endl << flush;
		
	state = waiting;
	
	time(&lastmsg);
}

// called by main.cc on each tick
bool Idle()
{
	if(state == active)return danced;
	
	double diff = difftime(time(NULL), lastmsg);
	if(state == waiting)
		if(diff > GUUTIMEOUT)
		{
			cerr << "timeout in wait\n";
			cout << puh() << "PRIVMSG " << str(botit, ',') << " :cancel\n" << flush;
			state = nothing;
			return false;
		}
	if(state != nothing)return danced;
	
	if(diff == IDLEMIN+(rand()%(IDLEMAX-IDLEMIN)))
		Initiate(0);
	return false;
}

// Shall we dance now?
static void GotText(const string &s)
{
	if(reply.size())reply += '\n';
	reply += s;
	
	tttlist::const_iterator i;
	
	for(i=lista->begin(); i!=lista->end(); i++)
		if(strfix(i->text) == reply)
		{
//			cout << "PRIVMSG bisqwit :(debug) Dancing: reply='" << reply << "'\n" << flush;
	
			Dance(*i);
			reply="";
			return;
		}
		
//	cout << "PRIVMSG bisqwit :(debug) No match: reply='" << reply << "'\n" << flush;
	
#if 0
	cerr << "'" << reply << "' wasn't: ";
	for(i=lista->begin(); i!=lista->end(); i++)
		cerr << "'" << i->text << "', ";
	cerr << "damn.\n";
#endif
}

// She is ready
static void OkReply(const string &from)
{
//	cout << "PRIVMSG bisqwit :(debug) Ok from " << from << "\n" << flush;
	
	from==from;
	if(state == waiting)
	{
		InitDebate(chatid, 0);	// 0 = this bot
	}
}

// She is impatient
static void GuuReply(const string &from, string s)
{
//	cout << "PRIVMSG bisqwit :(debug) Guu from " << from << "\n" << flush;
	
	if(state == nothing)
	{
		int me=-1, ind=-1, num=0;
		botit.clear();
		for(; !s.empty(); ind++)
		{
			unsigned p = s.find(' ');
			
			string temp = s.substr(0, p);
			
			if(ind==-1)
			{
				num = atoi(temp.c_str());
				me = -1;
			}
			else
			{
				if(temp == mynick)me=ind;
				botit.insert(botit.end(), temp);
			}
				
			if(p > s.size())break;
			
			s.erase(0, p+1);
 		}
		cout << puh() << "PRIVMSG " << from << " :ok, chat=" << num << " me=" << me << endl << flush;
		InitDebate(num, me);
	}
}

static void InitReply(const string &from, string s)
{
	if(state == nothing)
	{
		int n = atoi(s.c_str());
		cout << "PRIVMSG " << from << " :Ok, we'll try.\n" << flush;
		Initiate(n);
	}
	else if(state == waiting)
		cout << "PRIVMSG " << from << " :Already trying.\n" << flush;
	else
		cout << "PRIVMSG " << from << " :Sorry, not now.\n" << flush;
}

static void Cancel(const string &from)
{
	if(state == active || state == waiting)
	{
		cout << "PRIVMSG " << from << " :Interrupted.\n" << flush;
		cerr << "cancelled everything\n";
		// checkme
		danced = true;
		yippee = NULL;
		state = nothing;
	}
}

void PRIVMSG(const string &from, const string &to,
			 const vector<string> &rest)
{
	string nick,host;
	string s = str(rest);
	separate(nick,host, from);
	
	if(to == mynick)
	{
		if(s.substr(0,4) == "guu ")GuuReply(nick, s.substr(4));
		else if(s.substr(0,2) == "ok")OkReply(nick);
		else if(s.substr(0,4) == "fwd ")
		{
			cout << "PRIVMSG " << s.substr(4,512) << endl << flush;
		}
		else if(s == "cancel")Cancel(nick);
		else if(s.substr(0,5) == "init ")InitReply(nick, s.substr(5));
	}
	else if(to == thechan)
		if(state == active)
			if(nick == botit[waitingid])
				GotText(s);
	
	time(&lastmsg);
	
	to==to;
}

void JOIN(const string &from, const string &to,
		  const vector<string> &rest)
{
	AddUser(to, from);
	rest==rest;
}

void PART(const string &from, const string &to,
		  const vector<string> &rest)
{
	DelUser(to, from);
	rest==rest;
}

void KICK(const string &from, const string &to,
		  const vector<string> &rest)
{
	DelUser(to, rest[0], "");
	from==from;
}

void QUIT(const string &from, const string &to,
		  const vector<string> &rest)
{
	DelUser(to, from);
	rest==rest;
}
